<template>
  <div class="q-pa-md">
    <q-table
      title="Users"
      :rows="roles"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="MoreDeleteData"
    >
    <template v-slot:body-cell-permission_b="roles">
      <q-td :roles="roles" align="left" width="20px">
        <q-btn
          color="blue"
          icon="visibility"
          @click="ShowPermissionModal(roles.row)"
          size="sm"
          danse
          class="q-ml-sm"
        />
      </q-td>
    </template>
    <template v-slot:body-cell-action="roles">
      <q-td :roles="roles" align="left" width="20px">
        <q-btn
          color="primary"
          icon="edit"
          @click="ShowEditModal(roles.row)"
          size="sm"
          danse
          class="q-ml-sm"
        />
        <q-btn
          color="red"
          icon="delete"
          @click="ShowDeleteModal(roles.row)"
          size="sm"
          danse
          class="q-ml-sm"
        />
      </q-td>
    </template>
    
    <template v-slot:top>
      <q-btn
        color="primary"
        :disable="loading"
        label="Add Role"
        @click="ShowAddModal()"
      />
      <q-btn
        v-if="MoreDeleteData.length"
        class="q-ml-sm"
        color="red"
        :disable="loading"
        label="Delete Roles"
        @click="ShowMoreDeleteUsersModal()"
      />
      <q-space />
      <q-input
        dense
        rounded
        standout="bg-info text-white"
        v-model="search_text"
        input-class="text-right"
        class="q-ml-md"
      >
        <template v-slot:append>
          <q-icon v-if="search_text === ''" name="search" />
          <q-icon
            v-else
            name="clear"
            class="cursor-pointer"
            @click="search_text = ''"
          />
        </template>
      </q-input>
    </template>
    </q-table>

    <!-- permission modal -->
    <!-- <q-dialog
      v-model="PermissionModal"
      persistent
      :maximized="maximizedToggle"
      transition-show="slide-up"
      transition-hide="slide-down"
    >
      <q-card class="bg-white text-black">
        <q-bar>
          <q-space />

          <q-btn dense flat icon="minimize" @click="maximizedToggle = false" :disable="!maximizedToggle">
            <q-tooltip v-if="maximizedToggle" class="bg-white text-primary">Minimize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="crop_square" @click="maximizedToggle = true" :disable="maximizedToggle">
            <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary">Maximize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>

        <q-card-section>
          <div class="text-h6">{{PermissionData.name}}</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <table v-for="(permission, i) in PermissionData" :key="i">
            <th>
              <td>{{permission}}</td>
              <td v-if="permission.title">{{permission.title}}</td>
              <td v-if="permission.read">{{permission.read}}</td>
              <td v-if="permission.write">{{permission.write}}</td>
              <td v-if="permission.update">{{permission.update}}</td>
              <td v-if="permission.delete">{{permission.delete}}</td>
              <td v-if="permission.url">{{permission.url}}</td>
              <td v-if="permission.icon">{{permission.icon}}</td>
            </th>
            <tr>
              <td>ID</td>
              <td v-if="permission.title">{{permission.title}}</td>
              <td v-if="permission.read">{{permission.read}}</td>
              <td v-if="permission.write">{{permission.write}}</td>
              <td v-if="permission.update">{{permission.update}}</td>
              <td v-if="permission.delete">{{permission.delete}}</td>
              <td v-if="permission.url">{{permission.url}}</td>
              <td v-if="permission.icon">{{permission.icon}}</td>
            </tr>
          </table>

        </q-card-section>
      </q-card>
    </q-dialog> -->
    <!-- End permission modal -->

    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
      <q-card style="min-width: 350px" @keyup.enter="SendAddData" @keyup.esc="AddModalCancel()">
        <q-card-section>
          <div class="text-h6">{{ModalHeader}}</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input 
            dense 
            v-model="AddData.name" 
            autofocus 
          />
        </q-card-section>

        <q-card-section class="q-pt-none" style="text-align:center;">

          <q-btn
            class="q-ml-sm"
            color="blue"
            label="Assign Permission"
            @click="ShowAddPermissionModal()"
          />
        </q-card-section>

        <q-card-actions align="right" class="text-primary">
          <q-btn flat :label="EditModal ? 'Update':'Create'" @click="SendAddData"/>
          <q-btn flat label="Cancel" @click="AddModalCancel()"/>
        </q-card-actions>
      </q-card>
    </q-dialog>
    
    <q-dialog 
      v-model="AddPermissionModal" 
      :maximized="maximizedToggle"
      transition-show="slide-up"
      transition-hide="slide-down"
      persistent>
      <q-card class="bg-white text-black" >
        <q-bar>
          <q-space />
          <q-btn dense flat icon="minimize" @click="maximizedToggle = false" :disable="!maximizedToggle">
            <q-tooltip v-if="maximizedToggle" class="bg-white text-primary">Minimize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="crop_square" @click="maximizedToggle = true" :disable="maximizedToggle">
            <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary">Maximize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="close" @click="AddPermissionModalOk()">
            <q-tooltip class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card @keyup.enter="AddPermissionModalOk()" @keyup.esc="AddPermissionModalOk()">
          <q-card-section class="q-pt-none" v-for="(data, i) in AddPermissionModalTableRows" :key="i">
          <q-table
            style="margin:5px 0 5px 0;" 
            :hide-bottom="true" 
            :rows="AddPermissionModalTableRows[i]" 
            :columns="AddPermissionModalTableColumns[i]"
          >
          
            <template   v-slot:body-cell-title="data">
              <q-td :data="data" align="left" style='width: 400px !important'>
                  <q-input outline :dense="true"  v-model="data.row.title" :readonly="PermissionModal" />
              </q-td>
            </template>
            <template   v-slot:body-cell-router="data">
              <q-td :data="data" align="left" style='width: 400px !important'>
                  <q-input outline :dense="true"  v-model="data.row.router" :readonly="PermissionModal" />
              </q-td>
            </template>
            <template   v-slot:body-cell-iconUrl="data">
              <q-td :data="data" align="left" style='width: 400px !important'>
                  <q-input outline :dense="true"  v-model="data.row.iconUrl" :readonly="PermissionModal"/>
              </q-td>
            </template>
            <template   v-slot:body-cell-read="data">
              <q-td :data="data" align="left">
                  <q-checkbox size="sm"  v-model="data.row.read" :disable="PermissionModal"/>
              </q-td>
            </template>
            <template   v-slot:body-cell-write="data">
              <q-td :data="data" align="left">
                  <q-checkbox size="sm" v-model="data.row.write" :disable="PermissionModal"/>
              </q-td>
            </template>
            <template   v-slot:body-cell-update="data">
              <q-td :data="data" align="left">
                  <q-checkbox size="sm"  v-model="data.row.update" :disable="PermissionModal"/>
              </q-td>
            </template>
            <template   v-slot:body-cell-delete="data">
              <q-td :data="data" align="left">
                  <q-checkbox size="sm"  v-model="data.row.delete" :disable="PermissionModal"/>
              </q-td>
            </template>
            <template   v-slot:body-cell-input="data">
              <q-td :data="data" align="left">
                  <q-checkbox size="sm"  v-model="data.row.input" :disable="PermissionModal"/>
              </q-td>
            </template>
            <template   v-slot:body-cell-output="data">
              <q-td :data="data" align="left">
                  <q-checkbox size="sm"  v-model="data.row.output" :disable="PermissionModal"/>
              </q-td>
            </template>
          </q-table>

        </q-card-section>
        </q-card> 

        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Assign" @click="AddPermissionModalOk()"/>
          <!-- <q-btn flat label="Cancel" @click="AddPermissionModalCancel()"/> -->
        </q-card-actions>
        
      </q-card>
    </q-dialog> 
    <!-- End Add Dialog -->
  </div>
</template>

<script>
import { defineComponent } from 'vue'
import axios from 'axios'
import { ref } from 'vue'
import { mapActions } from 'vuex'
export default defineComponent({
  name: 'PageRoles',
  
  data(){
    return{
      maximizedToggle: true,
      roles: [],
      search_text: '',
      PermissionModal: false,
      PermissionData: null,
      AddPermissionModalTableRows:[],
      AddPermissionModalTableColumns: [],
      ModalHeader: '',
      AddModal: false,
      AddModalPermission: false,
      permission_default: [
        {name: 'Dashboard',title: 'Dashboard', url: '/', iconUrl: "inbox", read:false, write: false, update: false, delete: false,input: null, output: null},
        {name: 'Store',title: 'Store', url: '/store', iconUrl: "inbox", read:false, write: false, update: false, delete: false,input: null, output: null},
        {name: 'Category',title: 'Category', url: '/category', iconUrl: "category", read:false, write: false, update: false, delete: false,input: null, output: null},
        {name: 'Product',title: 'Product', url: '/product', iconUrl: "shopping_cart", read:false, write: false, update: false, delete: false,input: null, output: null},
        {name: 'Statistic',title: 'Statistic', url: '/statistic', iconUrl: "leaderboard", read:false,write: null, update: null, delete: null, input: false, output: false},
        {name: 'Users',title: 'Users', url: '/users', iconUrl: "person", read:false, write: false, update: false, delete: false,input: null, output: null},
        {name: 'Roles',title: 'Roles', url: '/roles', iconUrl: "settings", read:false, write: false, update: false, delete: false,input: null, output: null}
      ],
      
      AddData: {
        name: "",
        permission: []
      },
      EditModal: false,
      EditData: null,
      DeleteModal: false,
      DeleteData: null,
      MoreDeleteModal: false,
      MoreDeleteData: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: "left",
          style: 'width: 10px',
          sortable: true
        },
        {
          name: 'name',
          field: 'name',
          label: 'Role Name',
          align: 'left',
          sortable: true,
        },
        // {
        //   name: 'permission_b',
        //   field: 'permission_b',
        //   label: 'Permission',
        //   align: 'left'
        // },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
    }
  },
  async mounted(){
    this.$q.loading.show()
    this.get_roles()
  },
  methods:{
    ...mapActions('example', ['setUser']),
    async get_roles(){
      await axios.get('http://127.0.0.1:8000/api/role/get_roles').then((response) => {
        var data = response.data
        //console.log(response.data.data)
        var roles = []
        for(var i=0;i<data.length;i++){
          var json = {
            "index": i,
            "id": data[i].id,
            "name": data[i].name,
            "permission": JSON.parse(data[i].permission)
          }
          roles.push(json)
          //console.log(roles[i].permission)
        }
        this.roles = roles
        this.$q.loading.hide()
      }).catch((e)=>{
        var res = e.response
        this.$q.loading.hide()
        if(res.status == 401 || res.status == 419){
          this.$e("You are not authorized")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
        }
      })
    },


    ShowPermissionModal(role){
      this.PermissionModal = true
      var data = JSON.stringify(role.permission)
      this.AddData.permission = JSON.parse(data)
      //this.ShowAddPermissionModal()
    },
    
    ShowAddModal(){
      this.AddPermissionModalCancel()
      this.AddModal = true
      this.ModalHeader = "New Role"
    },
    AddModalCancel(){
      var store = JSON.stringify(this.$store.state.example.stateResources)
      this.AddData = {
        name: "",
        permission: JSON.parse(store)
      }
      this.AddModal = false
      this.EditModal = false
      this.AddPermissionModal = false
      this.ModalHeader = ''
    },
    ShowAddPermissionModal(){
      var columns = [];
      var json = [];
      this.AddPermissionModalTableRows = [];
      this.AddPermissionModalTableColumns = [];
      var per = this.AddData.permission;
      for(var i=0;i<per.length;i++){
        this.AddPermissionModalTableRows.push([per[i]]);
        columns = [
          {
          name: 'title',
          label: 'Resource Name',
          field: 'title',
          align: "left",
          style: 'width: 400px'
          },
          {
          name: 'url',
          label: 'Router',
          field: 'url',
          align: "left",
          style: 'width: 400px'
          },
          {
          name: 'iconUrl',
          label: 'Icon',
          field: 'iconUrl',
          align: "left",

          }
        ]
        if(per[i].read != null){
          json = {
            name: 'read',
            label: 'Read',
            field: 'read',
            align: "left",
            style: 'width: 10px'
          }
          columns.push(json);
        }
        if(per[i].write != null){
          json = {
            name: 'write',
            label: 'Write',
            field: 'write',
            align: "left",
            style: 'width: 10px'
          }
          columns.push(json);
        }
        if(per[i].update != null){
          json = {
            name: 'update',
            label: 'Update',
            field: 'update',
            align: "left",
            style: 'width: 10px'
          }
          columns.push(json);
        }
        if(per[i].delete != null){
          json = {
            name: 'delete',
            label: 'Delete',
            field: 'delete',
            align: "left",
            style: 'width: 10px'
          }
          columns.push(json);
        }
        if(per[i].input != null){
          json = {
            name: 'input',
            label: 'Input',
            field: 'input',
            align: "left",
            style: 'width: 10px'
          }
          columns.push(json);
        }
        if(per[i].output != null){
          json = {
            name: 'output',
            label: 'Output',
            field: 'output',
            align: "left",
            style: 'width: 10px'
          }
          columns.push(json);
        }
        this.AddPermissionModalTableColumns.push(columns);
        //console.log(this.AddPermissionModalTableColumns[i]);
      }
      // console.log(this.AddPermissionModalTableColumns);
      // console.log(this.AddPermissionModalTableRows);
      //this.AddPermissionModalTableRows = this.AddData.permission
      this.AddModal = false
      this.AddPermissionModal = true
      console.log(this.AddPermissionModal)
    },
    AddPermissionModalOk(){
      this.AddPermissionModalTableRows = []
      this.AddPermissionModalTableColumns = []
      this.AddPermissionModal = false
      if(!this.PermissionModal) this.AddModal = true; else {this.AddData.permission = []}
      this.PermissionModal = false
    },
    AddPermissionModalCancel(){
      this.AddPermissionModalTableRows = []
      this.AddPermissionModalTableColumns = []
      this.AddData.permission = JSON.stringify(this.$store.state.example.stateResources)
      this.AddData.permission = JSON.parse(this.AddData.permission)
      this.AddPermissionModal = false
      if(!this.PermissionModal) this.AddModal = true; else {this.AddData.permission = []}
      this.PermissionModal = false
    },
    
    async SendAddData(){
      if(this.AddData.name.length < 3){
        this.$e("The name must be at least 3 characters.")
        return 0;
      }
      if(this.AddData.permission == []){
        this.$e("The permission must be at full")
        return 0;
      }
      this.AddData.permission = JSON.stringify(this.AddData.permission)
      var url = this.AddData.id ? "http://127.0.0.1:8000/api/role/update_role" : "http://127.0.0.1:8000/api/role/create_role";
      this.$q.loading.show()
      
      await axios.post(url, this.AddData).then((res) => {
        // console.log("asdfas")
        // console.log(res)
        if(res.status == 201){
          this.$s("Succesfully Create User Data")
        }else
        if(res.status == 200){
          this.$s("Succesfully Update User Data")
          location.reload()
        }
        this.get_roles()
        this.AddModalCancel()
        this.$q.loading.hide()
      }).catch((e)=>{
        this.$q.loading.hide()
        var res = e.response
        if(e.status == 401){
          this.$e("You are not authorized")
          this.$q.loading.hide()
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else
        if(res.status == 422){
            if(res.data.errors.name){
              this.$e(res.data.errors.name[0])
            }
            if(res.data.errors.email){
              this.$e(res.data.errors.email[0])
            }
            if(res.data.errors.password){
              this.$e(res.data.errors.password[0])
            }
            if(res.data.errors.role_id){
              this.$e(res.data.errors.role_id[0])
            }
        }else{
            this.$e("Something Error")
        }
      }) 
    },

    ShowEditModal(role){
      this.AddPermissionModalCancel()
      this.AddModal = true
      this.EditModal = true
      this.ModalHeader = "Edit Role"
      this.AddData = {
        id: role.id,
        name:role.name,
        permission: role.permission
        //permission: this.permission_default
      }
    }
  }
})

</script>